import{s as ul,f as m,n as ml,o as pl}from"../chunks/scheduler.63274e7e.js";import{S as fl,i as hl,g as a,s as n,r as p,A as gl,h as r,f as i,c as s,j as ol,u as f,x as o,k as u,y as cl,a as l,v as h,d as g,t as c,w as v}from"../chunks/index.bf3f3f8e.js";import{H as d,E as vl}from"../chunks/EditOnGithub.7d836abf.js";function dl(ii){let w,Ot,Ut,qt,_,zt,x,Rt,M,li='You can find the 👉 <a href="https://huggingface.co/datasets/huggingface-ml-4-games-course/unity-demos/resolve/main/unit1/Jammo%20the%20Robot%20Sentis%20(v2).zip?download=true" rel="nofollow">complete Unity project here</a>',Bt,$,Et,L,ni='The Sentis Documentation 👉 <a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">https://docs.unity3d.com/Packages/com.unity.sentis@latest</a>',Jt,C,si='<li><p>Open the Jammo project</p></li> <li><p>Click <a href="https://tinyurl.com/4eun48fb" rel="nofollow">Sentis Pre-Release package</a> or go to Window &gt; Package Manager, click the + icon, select “Add package by name…” and type “com.unity.sentis”</p></li>',Wt,H,ai,Ft,y,ri="<li>Press the Add button to install the package.</li>",Nt,S,oi,Yt,P,Dt,k,ui='<a href="https://github.com/huggingface/sharp-transformers" rel="nofollow">Sharp Transformers</a> is a Unity plugin of utilities to <strong>run Transformer 🤗 models in Unity games</strong>.',Vt,I,mi="We need to do it for the tokenization step.",Kt,j,pi="Go to “Window” > “Package Manager” to open the Package Manager.",Qt,G,fi="Click the ”+” in the upper left-hand corner and select “Add package from git URL”.",Xt,U,hi='Enter the URL of this repository and click “Add”: <a href="https://github.com/huggingface/sharp-transformers.git" rel="nofollow">https://github.com/huggingface/sharp-transformers.git</a>',Zt,A,te,O,gi='As described in <a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">Sentis documentation</a>, to use Sentis to run a neural network in Unity, we need to follow these steps.',ee,q,ci="<li><p>Use the Unity.Sentis namespace.</p></li> <li><p><strong>Load a neural network</strong> model file.</p></li> <li><p><strong>Create input</strong> for the model.</p></li> <li><p><strong>Create an inference engine</strong> (a worker).</p></li> <li><p><strong>Run the model</strong> with the input to infer a result.</p></li> <li><p><strong>Get the result</strong>.</p></li>",ie,z,vi="In our case, we do all of this in <strong>SentenceSimilarity.cs</strong> file, that will be attached to our robot.",le,R,di="In awake, we:",ne,B,wi="<li><p><strong>Load our neural network.</strong></p></li> <li><p>Create an <strong>inference engine</strong> (a worker).</p></li> <li><p><strong>Create an operator</strong>, that will allow us to perform operations with tensors.</p></li>",se,E,yi,ae,J,bi="We have three functions:",re,W,Ti="<li><em>Encode</em>: takes our player input (text), <strong>tokenizes it, and embeds it</strong>.</li>",oe,F,_i,ue,b,xi="<li><em>SentenceSimilarityScores</em>: <strong>calculate the similarity scores</strong> between the input embed (what the user typed) and the comparison embeds (the robot action list)</li>",me,N,Mi,pe,T,$i="<li><em>RankSimilarityScores</em>: get the <strong>most similar action</strong> and its index given the player input</li>",fe,Y,Li,he,D,ge,V,Ci="We need to define the <strong>behavior of our robot</strong>.",ce,K,Hi="The idea is that our robot has different possible actions and the choice of the actions <strong>will depend on most similar actions</strong>.",ve,Q,Si="We need first to define the <em>Finite State Machine</em>, a simple <strong>classical AI technique where each State defines a certain behavior</strong>.",de,X,Pi="Then, we’ll make the utility function <strong>that will select the State hence the series of actions to perform</strong>.",we,Z,ye,tt,ki="In a state machine, <strong>each state represents a behavior</strong>, for instance, moving to a column, saying hello, etc. Based on the state the agent is <strong>it will perform a series of actions</strong>.",be,et,Ii="In our case, we have 7 states:",Te,it,ji,_e,lt,Gi="The first thing we need to do is create an enum called State that contains each of the possible States:",xe,nt,Ui,Me,st,Ai="Because we need to constantly check the state, <strong>we define the state machine into the Update() method using a switch system where each case is a state</strong>.",$e,at,Oi,Le,rt,qi="For each state case, we define the behavior of our agents, for instance in our state Hello, the robot <strong>must move towards the player, face him correctly, and then launch its Hello animation, then go back to an Idle State</strong>.",Ce,ot,zi,He,ut,Ri="We have now defined the behavior for each different State. The magic here will come from the fact <strong>that’s the language model that will define what State is the closest to the Player input</strong>. And in the utility function, we call this state.",Se,mt,Pe,pt,Bi="Our action list looks like this:",ke,ft,Ei,Ie,ht,Ji="<li><p>The sentence is what will be embedded in the AI model.</p></li> <li><p>The verb is the State</p></li> <li><p>Noun (if any) is the object to interact with (Pillar, Cube, etc.)</p></li>",je,gt,Wi="This utility function will <strong>select the Verb and Noun associated with the sentence having the highest similarity score with the player input text.</strong>",Ge,ct,Fi="But first, to <strong>get rid of a lot of strange input text</strong>, we need to have a similarity <strong>score threshold</strong>.",Ue,vt,Ni="For example, if I say “Look at all the rabbits”, <strong>none of our possible actions are relevant</strong>. Hence instead of choosing the action with the highest score, we’ll call the State Puzzled which will animate the robot with a perplexed animation.",Ae,dt,Yi,Oe,wt,Di="If the score is higher, then <strong>we’ll get the verb corresponding to a State and the noun (goalObject) if any</strong>.",qe,yt,Vi="We set the state corresponding to the verb. That will activate the behavior corresponding to it.",ze,bt,Ki,Re,Tt,Qi="And that’s it, <strong>now we’re ready to interact with our robot!</strong>",Be,_t,Ee,xt,Xi="In this step, you just need to click on the play button in the editor. And you <strong>can prompt some orders and see the results</strong>!",Je,Mt,Zi="That’s nice! But the best way to learn is to try things, break things and modify the demo.",We,$t,Fe,Lt,tl="Adding a new action is quite easy. Let’s take an example:",Ne,Ct,el="<li><p>Copy the YellowPillar game object and move it</p></li> <li><p>Change the name to GreenPillar</p></li> <li><p>Create a new material and set it to green</p></li> <li><p>Place the material on GreenPillar</p></li>",Ye,Ht,il="Now that we’ve placed the new game object, we need to add this possibility into the sentences and click on Jammo_Player.",De,St,ll="In the list of actions click on the plus button and fill in this new action item:",Ve,Pt,nl,Ke,kt,sl="<li>Add Go to the green column</li> <li>GoTo</li> <li>GreenColumn</li>",Qe,It,al="And that’s it! <strong>You can easily iterate and add more actions to your game</strong>.",Xe,jt,rl="Again, don’t forget to test the similarity threshold, <strong>to see if you need to increase it or decrease it</strong>.",Ze,Gt,ti,At,ei;return _=new d({props:{title:"Let’s build our smart robot NPC demo 🤖",local:"lets-build-our-smart-robot-npc-demo-",headingTag:"h1"}}),x=new d({props:{title:"Step 0: Get the project files",local:"step-0-get-the-project-files",headingTag:"h2"}}),$=new d({props:{title:"Step 1: Install Unity Sentis",local:"step-1-install-unity-sentis",headingTag:"h2"}}),P=new d({props:{title:"Step 2: Install Sharp Transformers 💪",local:"step-2-install-sharp-transformers-",headingTag:"h2"}}),A=new d({props:{title:"Step 3: Build the inference process 🧠",local:"step-3-build-the-inference-process-",headingTag:"h2"}}),D=new d({props:{title:"Step 4: Build the Robot Behavior 🤖",local:"step-4-build-the-robot-behavior-",headingTag:"h2"}}),Z=new d({props:{title:"The State Machine 🧠🤖",local:"the-state-machine-",headingTag:"h3"}}),mt=new d({props:{title:"Let’s define the Utility Function 📈",local:"lets-define-the-utility-function-",headingTag:"h3"}}),_t=new d({props:{title:"Step 5: Let’s interact with our Robot 🤖",local:"step-5-lets-interact-with-our-robot-",headingTag:"h2"}}),$t=new d({props:{title:"(Optional) Improving the game: let’s add a new action",local:"optional-improving-the-game-lets-add-a-new-action",headingTag:"h2"}}),Gt=new vl({props:{source:"https://github.com/huggingface/making-games-with-ai-course/blob/main/units/en/unit1/make-demo.mdx"}}),{c(){w=a("meta"),Ot=n(),Ut=a("p"),qt=n(),p(_.$$.fragment),zt=n(),p(x.$$.fragment),Rt=n(),M=a("p"),M.innerHTML=li,Bt=n(),p($.$$.fragment),Et=n(),L=a("p"),L.innerHTML=ni,Jt=n(),C=a("ol"),C.innerHTML=si,Wt=n(),H=a("img"),Ft=n(),y=a("ol"),y.innerHTML=ri,Nt=n(),S=a("img"),Yt=n(),p(P.$$.fragment),Dt=n(),k=a("p"),k.innerHTML=ui,Vt=n(),I=a("p"),I.textContent=mi,Kt=n(),j=a("p"),j.textContent=pi,Qt=n(),G=a("p"),G.textContent=fi,Xt=n(),U=a("p"),U.innerHTML=hi,Zt=n(),p(A.$$.fragment),te=n(),O=a("p"),O.innerHTML=gi,ee=n(),q=a("ol"),q.innerHTML=ci,ie=n(),z=a("p"),z.innerHTML=vi,le=n(),R=a("p"),R.textContent=di,ne=n(),B=a("ol"),B.innerHTML=wi,se=n(),E=a("img"),ae=n(),J=a("p"),J.textContent=bi,re=n(),W=a("ol"),W.innerHTML=Ti,oe=n(),F=a("img"),ue=n(),b=a("ol"),b.innerHTML=xi,me=n(),N=a("img"),pe=n(),T=a("ol"),T.innerHTML=$i,fe=n(),Y=a("img"),he=n(),p(D.$$.fragment),ge=n(),V=a("p"),V.innerHTML=Ci,ce=n(),K=a("p"),K.innerHTML=Hi,ve=n(),Q=a("p"),Q.innerHTML=Si,de=n(),X=a("p"),X.innerHTML=Pi,we=n(),p(Z.$$.fragment),ye=n(),tt=a("p"),tt.innerHTML=ki,be=n(),et=a("p"),et.textContent=Ii,Te=n(),it=a("img"),_e=n(),lt=a("p"),lt.textContent=Gi,xe=n(),nt=a("img"),Me=n(),st=a("p"),st.innerHTML=Ai,$e=n(),at=a("img"),Le=n(),rt=a("p"),rt.innerHTML=qi,Ce=n(),ot=a("img"),He=n(),ut=a("p"),ut.innerHTML=Ri,Se=n(),p(mt.$$.fragment),Pe=n(),pt=a("p"),pt.textContent=Bi,ke=n(),ft=a("img"),Ie=n(),ht=a("ul"),ht.innerHTML=Ji,je=n(),gt=a("p"),gt.innerHTML=Wi,Ge=n(),ct=a("p"),ct.innerHTML=Fi,Ue=n(),vt=a("p"),vt.innerHTML=Ni,Ae=n(),dt=a("img"),Oe=n(),wt=a("p"),wt.innerHTML=Di,qe=n(),yt=a("p"),yt.textContent=Vi,ze=n(),bt=a("img"),Re=n(),Tt=a("p"),Tt.innerHTML=Qi,Be=n(),p(_t.$$.fragment),Ee=n(),xt=a("p"),xt.innerHTML=Xi,Je=n(),Mt=a("p"),Mt.textContent=Zi,We=n(),p($t.$$.fragment),Fe=n(),Lt=a("p"),Lt.textContent=tl,Ne=n(),Ct=a("ul"),Ct.innerHTML=el,Ye=n(),Ht=a("p"),Ht.textContent=il,De=n(),St=a("p"),St.textContent=ll,Ve=n(),Pt=a("img"),Ke=n(),kt=a("ul"),kt.innerHTML=sl,Qe=n(),It=a("p"),It.innerHTML=al,Xe=n(),jt=a("p"),jt.innerHTML=rl,Ze=n(),p(Gt.$$.fragment),ti=n(),At=a("p"),this.h()},l(t){const e=gl("svelte-u9bgzb",document.head);w=r(e,"META",{name:!0,content:!0}),e.forEach(i),Ot=s(t),Ut=r(t,"P",{}),ol(Ut).forEach(i),qt=s(t),f(_.$$.fragment,t),zt=s(t),f(x.$$.fragment,t),Rt=s(t),M=r(t,"P",{"data-svelte-h":!0}),o(M)!=="svelte-1yl9hlo"&&(M.innerHTML=li),Bt=s(t),f($.$$.fragment,t),Et=s(t),L=r(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-opv8w8"&&(L.innerHTML=ni),Jt=s(t),C=r(t,"OL",{"data-svelte-h":!0}),o(C)!=="svelte-1be145u"&&(C.innerHTML=si),Wt=s(t),H=r(t,"IMG",{src:!0,alt:!0}),Ft=s(t),y=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(y)!=="svelte-5tt8x1"&&(y.innerHTML=ri),Nt=s(t),S=r(t,"IMG",{src:!0,alt:!0}),Yt=s(t),f(P.$$.fragment,t),Dt=s(t),k=r(t,"P",{"data-svelte-h":!0}),o(k)!=="svelte-1z124e9"&&(k.innerHTML=ui),Vt=s(t),I=r(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-xasv72"&&(I.textContent=mi),Kt=s(t),j=r(t,"P",{"data-svelte-h":!0}),o(j)!=="svelte-1qa8kbx"&&(j.textContent=pi),Qt=s(t),G=r(t,"P",{"data-svelte-h":!0}),o(G)!=="svelte-19zcx5u"&&(G.textContent=fi),Xt=s(t),U=r(t,"P",{"data-svelte-h":!0}),o(U)!=="svelte-1bqyha7"&&(U.innerHTML=hi),Zt=s(t),f(A.$$.fragment,t),te=s(t),O=r(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-gwh6bq"&&(O.innerHTML=gi),ee=s(t),q=r(t,"OL",{"data-svelte-h":!0}),o(q)!=="svelte-11c6hj8"&&(q.innerHTML=ci),ie=s(t),z=r(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-1bxothf"&&(z.innerHTML=vi),le=s(t),R=r(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-17c2lau"&&(R.textContent=di),ne=s(t),B=r(t,"OL",{"data-svelte-h":!0}),o(B)!=="svelte-1mwm3hf"&&(B.innerHTML=wi),se=s(t),E=r(t,"IMG",{src:!0,alt:!0}),ae=s(t),J=r(t,"P",{"data-svelte-h":!0}),o(J)!=="svelte-gchvph"&&(J.textContent=bi),re=s(t),W=r(t,"OL",{"data-svelte-h":!0}),o(W)!=="svelte-1bbbmof"&&(W.innerHTML=Ti),oe=s(t),F=r(t,"IMG",{src:!0,alt:!0}),ue=s(t),b=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(b)!=="svelte-ehcevs"&&(b.innerHTML=xi),me=s(t),N=r(t,"IMG",{src:!0,alt:!0}),pe=s(t),T=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(T)!=="svelte-q0d6cq"&&(T.innerHTML=$i),fe=s(t),Y=r(t,"IMG",{src:!0,alt:!0}),he=s(t),f(D.$$.fragment,t),ge=s(t),V=r(t,"P",{"data-svelte-h":!0}),o(V)!=="svelte-15whxm9"&&(V.innerHTML=Ci),ce=s(t),K=r(t,"P",{"data-svelte-h":!0}),o(K)!=="svelte-1lrk8k1"&&(K.innerHTML=Hi),ve=s(t),Q=r(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-1kn8gok"&&(Q.innerHTML=Si),de=s(t),X=r(t,"P",{"data-svelte-h":!0}),o(X)!=="svelte-4iyzzc"&&(X.innerHTML=Pi),we=s(t),f(Z.$$.fragment,t),ye=s(t),tt=r(t,"P",{"data-svelte-h":!0}),o(tt)!=="svelte-5rbi8n"&&(tt.innerHTML=ki),be=s(t),et=r(t,"P",{"data-svelte-h":!0}),o(et)!=="svelte-1fffpiy"&&(et.textContent=Ii),Te=s(t),it=r(t,"IMG",{src:!0,alt:!0}),_e=s(t),lt=r(t,"P",{"data-svelte-h":!0}),o(lt)!=="svelte-2wbpmd"&&(lt.textContent=Gi),xe=s(t),nt=r(t,"IMG",{src:!0,alt:!0}),Me=s(t),st=r(t,"P",{"data-svelte-h":!0}),o(st)!=="svelte-120cind"&&(st.innerHTML=Ai),$e=s(t),at=r(t,"IMG",{src:!0,alt:!0}),Le=s(t),rt=r(t,"P",{"data-svelte-h":!0}),o(rt)!=="svelte-1shiqaw"&&(rt.innerHTML=qi),Ce=s(t),ot=r(t,"IMG",{src:!0,alt:!0}),He=s(t),ut=r(t,"P",{"data-svelte-h":!0}),o(ut)!=="svelte-1jrao99"&&(ut.innerHTML=Ri),Se=s(t),f(mt.$$.fragment,t),Pe=s(t),pt=r(t,"P",{"data-svelte-h":!0}),o(pt)!=="svelte-bsbp3"&&(pt.textContent=Bi),ke=s(t),ft=r(t,"IMG",{src:!0,alt:!0}),Ie=s(t),ht=r(t,"UL",{"data-svelte-h":!0}),o(ht)!=="svelte-6bwl87"&&(ht.innerHTML=Ji),je=s(t),gt=r(t,"P",{"data-svelte-h":!0}),o(gt)!=="svelte-16jnw1u"&&(gt.innerHTML=Wi),Ge=s(t),ct=r(t,"P",{"data-svelte-h":!0}),o(ct)!=="svelte-gpawhm"&&(ct.innerHTML=Fi),Ue=s(t),vt=r(t,"P",{"data-svelte-h":!0}),o(vt)!=="svelte-1hi969r"&&(vt.innerHTML=Ni),Ae=s(t),dt=r(t,"IMG",{src:!0,alt:!0}),Oe=s(t),wt=r(t,"P",{"data-svelte-h":!0}),o(wt)!=="svelte-idtp6m"&&(wt.innerHTML=Di),qe=s(t),yt=r(t,"P",{"data-svelte-h":!0}),o(yt)!=="svelte-1yk26hk"&&(yt.textContent=Vi),ze=s(t),bt=r(t,"IMG",{src:!0,alt:!0}),Re=s(t),Tt=r(t,"P",{"data-svelte-h":!0}),o(Tt)!=="svelte-hcv1yn"&&(Tt.innerHTML=Qi),Be=s(t),f(_t.$$.fragment,t),Ee=s(t),xt=r(t,"P",{"data-svelte-h":!0}),o(xt)!=="svelte-1kbnmju"&&(xt.innerHTML=Xi),Je=s(t),Mt=r(t,"P",{"data-svelte-h":!0}),o(Mt)!=="svelte-1t6d83x"&&(Mt.textContent=Zi),We=s(t),f($t.$$.fragment,t),Fe=s(t),Lt=r(t,"P",{"data-svelte-h":!0}),o(Lt)!=="svelte-1rlfwth"&&(Lt.textContent=tl),Ne=s(t),Ct=r(t,"UL",{"data-svelte-h":!0}),o(Ct)!=="svelte-1dl51k5"&&(Ct.innerHTML=el),Ye=s(t),Ht=r(t,"P",{"data-svelte-h":!0}),o(Ht)!=="svelte-22rtac"&&(Ht.textContent=il),De=s(t),St=r(t,"P",{"data-svelte-h":!0}),o(St)!=="svelte-18hx0iy"&&(St.textContent=ll),Ve=s(t),Pt=r(t,"IMG",{src:!0,alt:!0}),Ke=s(t),kt=r(t,"UL",{"data-svelte-h":!0}),o(kt)!=="svelte-q2rtbz"&&(kt.innerHTML=sl),Qe=s(t),It=r(t,"P",{"data-svelte-h":!0}),o(It)!=="svelte-wsbu0l"&&(It.innerHTML=al),Xe=s(t),jt=r(t,"P",{"data-svelte-h":!0}),o(jt)!=="svelte-11a9ito"&&(jt.innerHTML=rl),Ze=s(t),f(Gt.$$.fragment,t),ti=s(t),At=r(t,"P",{}),ol(At).forEach(i),this.h()},h(){u(w,"name","hf:doc:metadata"),u(w,"content",wl),m(H.src,ai="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis1.jpg")||u(H,"src",ai),u(H,"alt","Sentis"),u(y,"start","3"),m(S.src,oi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis2.png")||u(S,"src",oi),u(S,"alt","Sentis"),m(E.src,yi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity1.jpg")||u(E,"src",yi),u(E,"alt","Sentis Similarity"),m(F.src,_i="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity2.jpg")||u(F,"src",_i),u(F,"alt","Sentis Similarity"),u(b,"start","2"),m(N.src,Mi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity3.jpg")||u(N,"src",Mi),u(N,"alt","Sentis Similarity"),u(T,"start","3"),m(Y.src,Li="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity4.jpg")||u(Y,"src",Li),u(Y,"alt","Sentis Similarity"),m(it.src,ji="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm.jpg")||u(it,"src",ji),u(it,"alt","Jammo State Machine"),m(nt.src,Ui="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm2.jpg")||u(nt,"src",Ui),u(nt,"alt","Jammo State Machine"),m(at.src,Oi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm3.jpg")||u(at,"src",Oi),u(at,"alt","Jammo State Machine"),m(ot.src,zi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm4.jpg")||u(ot,"src",zi),u(ot,"alt","Jammo State Machine"),m(ft.src,Ei="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/utility1.jpg")||u(ft,"src",Ei),u(ft,"alt","Utility"),m(dt.src,Yi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/rabbits.gif")||u(dt,"src",Yi),u(dt,"alt","Jammo rabbits"),m(bt.src,Ki="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/utility2.jpg")||u(bt,"src",Ki),u(bt,"alt","Utility"),m(Pt.src,nl="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/optional-jammo1.jpg")||u(Pt,"src",nl),u(Pt,"alt","Utility")},m(t,e){cl(document.head,w),l(t,Ot,e),l(t,Ut,e),l(t,qt,e),h(_,t,e),l(t,zt,e),h(x,t,e),l(t,Rt,e),l(t,M,e),l(t,Bt,e),h($,t,e),l(t,Et,e),l(t,L,e),l(t,Jt,e),l(t,C,e),l(t,Wt,e),l(t,H,e),l(t,Ft,e),l(t,y,e),l(t,Nt,e),l(t,S,e),l(t,Yt,e),h(P,t,e),l(t,Dt,e),l(t,k,e),l(t,Vt,e),l(t,I,e),l(t,Kt,e),l(t,j,e),l(t,Qt,e),l(t,G,e),l(t,Xt,e),l(t,U,e),l(t,Zt,e),h(A,t,e),l(t,te,e),l(t,O,e),l(t,ee,e),l(t,q,e),l(t,ie,e),l(t,z,e),l(t,le,e),l(t,R,e),l(t,ne,e),l(t,B,e),l(t,se,e),l(t,E,e),l(t,ae,e),l(t,J,e),l(t,re,e),l(t,W,e),l(t,oe,e),l(t,F,e),l(t,ue,e),l(t,b,e),l(t,me,e),l(t,N,e),l(t,pe,e),l(t,T,e),l(t,fe,e),l(t,Y,e),l(t,he,e),h(D,t,e),l(t,ge,e),l(t,V,e),l(t,ce,e),l(t,K,e),l(t,ve,e),l(t,Q,e),l(t,de,e),l(t,X,e),l(t,we,e),h(Z,t,e),l(t,ye,e),l(t,tt,e),l(t,be,e),l(t,et,e),l(t,Te,e),l(t,it,e),l(t,_e,e),l(t,lt,e),l(t,xe,e),l(t,nt,e),l(t,Me,e),l(t,st,e),l(t,$e,e),l(t,at,e),l(t,Le,e),l(t,rt,e),l(t,Ce,e),l(t,ot,e),l(t,He,e),l(t,ut,e),l(t,Se,e),h(mt,t,e),l(t,Pe,e),l(t,pt,e),l(t,ke,e),l(t,ft,e),l(t,Ie,e),l(t,ht,e),l(t,je,e),l(t,gt,e),l(t,Ge,e),l(t,ct,e),l(t,Ue,e),l(t,vt,e),l(t,Ae,e),l(t,dt,e),l(t,Oe,e),l(t,wt,e),l(t,qe,e),l(t,yt,e),l(t,ze,e),l(t,bt,e),l(t,Re,e),l(t,Tt,e),l(t,Be,e),h(_t,t,e),l(t,Ee,e),l(t,xt,e),l(t,Je,e),l(t,Mt,e),l(t,We,e),h($t,t,e),l(t,Fe,e),l(t,Lt,e),l(t,Ne,e),l(t,Ct,e),l(t,Ye,e),l(t,Ht,e),l(t,De,e),l(t,St,e),l(t,Ve,e),l(t,Pt,e),l(t,Ke,e),l(t,kt,e),l(t,Qe,e),l(t,It,e),l(t,Xe,e),l(t,jt,e),l(t,Ze,e),h(Gt,t,e),l(t,ti,e),l(t,At,e),ei=!0},p:ml,i(t){ei||(g(_.$$.fragment,t),g(x.$$.fragment,t),g($.$$.fragment,t),g(P.$$.fragment,t),g(A.$$.fragment,t),g(D.$$.fragment,t),g(Z.$$.fragment,t),g(mt.$$.fragment,t),g(_t.$$.fragment,t),g($t.$$.fragment,t),g(Gt.$$.fragment,t),ei=!0)},o(t){c(_.$$.fragment,t),c(x.$$.fragment,t),c($.$$.fragment,t),c(P.$$.fragment,t),c(A.$$.fragment,t),c(D.$$.fragment,t),c(Z.$$.fragment,t),c(mt.$$.fragment,t),c(_t.$$.fragment,t),c($t.$$.fragment,t),c(Gt.$$.fragment,t),ei=!1},d(t){t&&(i(Ot),i(Ut),i(qt),i(zt),i(Rt),i(M),i(Bt),i(Et),i(L),i(Jt),i(C),i(Wt),i(H),i(Ft),i(y),i(Nt),i(S),i(Yt),i(Dt),i(k),i(Vt),i(I),i(Kt),i(j),i(Qt),i(G),i(Xt),i(U),i(Zt),i(te),i(O),i(ee),i(q),i(ie),i(z),i(le),i(R),i(ne),i(B),i(se),i(E),i(ae),i(J),i(re),i(W),i(oe),i(F),i(ue),i(b),i(me),i(N),i(pe),i(T),i(fe),i(Y),i(he),i(ge),i(V),i(ce),i(K),i(ve),i(Q),i(de),i(X),i(we),i(ye),i(tt),i(be),i(et),i(Te),i(it),i(_e),i(lt),i(xe),i(nt),i(Me),i(st),i($e),i(at),i(Le),i(rt),i(Ce),i(ot),i(He),i(ut),i(Se),i(Pe),i(pt),i(ke),i(ft),i(Ie),i(ht),i(je),i(gt),i(Ge),i(ct),i(Ue),i(vt),i(Ae),i(dt),i(Oe),i(wt),i(qe),i(yt),i(ze),i(bt),i(Re),i(Tt),i(Be),i(Ee),i(xt),i(Je),i(Mt),i(We),i(Fe),i(Lt),i(Ne),i(Ct),i(Ye),i(Ht),i(De),i(St),i(Ve),i(Pt),i(Ke),i(kt),i(Qe),i(It),i(Xe),i(jt),i(Ze),i(ti),i(At)),i(w),v(_,t),v(x,t),v($,t),v(P,t),v(A,t),v(D,t),v(Z,t),v(mt,t),v(_t,t),v($t,t),v(Gt,t)}}}const wl='{"title":"Let’s build our smart robot NPC demo 🤖","local":"lets-build-our-smart-robot-npc-demo-","sections":[{"title":"Step 0: Get the project files","local":"step-0-get-the-project-files","sections":[],"depth":2},{"title":"Step 1: Install Unity Sentis","local":"step-1-install-unity-sentis","sections":[],"depth":2},{"title":"Step 2: Install Sharp Transformers 💪","local":"step-2-install-sharp-transformers-","sections":[],"depth":2},{"title":"Step 3: Build the inference process 🧠","local":"step-3-build-the-inference-process-","sections":[],"depth":2},{"title":"Step 4: Build the Robot Behavior 🤖","local":"step-4-build-the-robot-behavior-","sections":[{"title":"The State Machine 🧠🤖","local":"the-state-machine-","sections":[],"depth":3},{"title":"Let’s define the Utility Function 📈","local":"lets-define-the-utility-function-","sections":[],"depth":3}],"depth":2},{"title":"Step 5: Let’s interact with our Robot 🤖","local":"step-5-lets-interact-with-our-robot-","sections":[],"depth":2},{"title":"(Optional) Improving the game: let’s add a new action","local":"optional-improving-the-game-lets-add-a-new-action","sections":[],"depth":2}],"depth":1}';function yl(ii){return pl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class xl extends fl{constructor(w){super(),hl(this,w,yl,dl,ul,{})}}export{xl as component};
